--------------------------------------------
-- Module Name: calc_ones_function
--------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

Entity calc_ones_function  Is Port (
	Signal ain : in STD_LOGIC_VECTOR (7 downto 0);
	Signal number_of_ones : out STD_LOGIC_VECTOR (2 downto 0)
);
end calc_ones_function ;

Architecture behavior of calc_ones_function  Is
		
	function calc_ones  (signal a_in : in STD_LOGIC_VECTOR)
	return std_logic_vector is
	variable count : STD_LOGIC_VECTOR(2 downto 0) := "000"; 
	variable k : integer := 0;
	
	begin
		L: while k <= 7 loop
			if (a_in(k) = '1') then
				count := count + '1';
			end if;
			k := k + 1;
		end loop L;
		
		return count;
	end calc_ones;
	
begin		 
	process (ain)
	begin
		number_of_ones <= calc_ones(ain);
	end process;
end behavior;